; Constant registers 
; c0-c3 - world space transposed
; c8-c11 - world * view * proj
; c12 - Light Direction (In World Space)
; c24 - camera direction
; c33 - range value
;
; Input registers
; v0 - Position
; v7 - Texture 
; v8 - Tangent
; v9 - SxT
vs.1.1

; position in clip space
m4x4 oPos, v0, c8

m3x3 r3, v8, c0	; generate tangent U
m3x3 r5, v9, c0	; generate normal W

; Cross product
; generate binormal V
mul r0, -r3.zxyw, r5.yzxw;
mad r4, -r3.yzxw, r5.zxyw,-r0;

; position in world space
m4x4 r2, v0, c0		

; get light vector
add r10, r2, -c12

; normalize light vector
dp3 r11.x, r10.xyz, r10.xyz		
rsq r11.xyz, r11.x			
mul r10.xyz, r10.xyz, r11.xyz	

; get a vector toward the camera/eye V
add r6, -r10, c24

; normalize eye vector V
dp3 r11.x,  r6.xyz, r6.xyz	
rsq r11.xyz, r11.x			
mul r6.xyz, r6.xyz, r11.xyz	

add r6.xyz, r6.xyz, -c12		; get half angle

; normalize half angle
dp3 r11.x, r6.xyz, r6.xyz		
rsq r11.xyz, r11.x			
mul r6.xyz, r6.xyz, r11.xyz	

; transform the half angle vector into texture space
dp3 oT3.x,r3,r6
dp3 oT3.y,r4,r6
dp3 oT3.z,r5,r6

;transform the light vector with U, V, W
dp3 oT2.x, r3, r10
dp3 oT2.y, r4, r10
dp3 oT2.z, r5, r10

mov oT1.xy, v7.xy ; normal map
mov oT0.xy, v7.xy ; normal map






	  	  





